function output=advect(field,u,v,lon,lat)
% output=advect(field,u,v,lon,lat)

output=zeros(size(field));

%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
% for iLat=2:length(lat)-1
%     for iLon=2:length(lon)-1
%         
%         distX=lldistkm([lat(iLat) lon(iLon+1)],[lat(iLat) lon(iLon-1)])*1000;
%         distY=lldistkm([lat(iLat+1) lon(iLon)],[lat(iLat-1) lon(iLon)])*1000;
%         
%         ddy=(field(iLon,iLat+1,:,:)-field(iLon,iLat-1,:,:))/distY;
%         ddx=(field(iLon+1,iLat,:,:)-field(iLon-1,iLat,:,:))/distX;
%         
%         output(iLon,iLat,:,:)=u(iLon,iLat,:,:).*ddx + v(iLon,iLat,:,:).*ddy;
% 
%     end
% end
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
[nlon,nlat,nlev,nt]=size(field);

iLat=2:nlat-1;
iLon=2:nlon-1;

%distX
distX=zeros(nlat,1);
for j=2:nlat-1
    distX(j)=lldistkm([lat(j) lon(3)],[lat(j) lon(1)])*1000;
end
distX=permute(repmat(distX,[1,nlon,nlev,nt]),[2,1,3,4]);
%distY
distY=lldistkm([lat(3) lon(1)],[lat(1) lon(1)])*1000;  

ddy=(field(iLon,iLat+1,:,:)-field(iLon,iLat-1,:,:))/distY;
ddx=(field(iLon+1,iLat,:,:)-field(iLon-1,iLat,:,:))./distX(iLon,iLat,:,:);

output(iLon,iLat,:,:)=u(iLon,iLat,:,:).*ddx + v(iLon,iLat,:,:).*ddy;
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




