function [uGeostr,vGeostr]=calcGeostr(geopot,lon,lat,f)
%[uGeostr,vGeostr]=calcGeostr(geopot,lon,lat,f0)

f=2*7.2921e-5*sin(lat*pi/180);

uGeostr=zeros(size(geopot));
vGeostr=zeros(size(geopot));

%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
% for iLat=2:length(lat)-1
%     for iLon=2:length(lon)-1
%         
%         distX=lldistkm([lat(iLat) lon(iLon+1)],[lat(iLat) lon(iLon-1)])*1000;
%         distY=lldistkm([lat(iLat+1) lon(iLon)],[lat(iLat-1) lon(iLon)])*1000;
%         
%         dZdy=(geopot(iLon,iLat+1,:,:)-geopot(iLon,iLat-1,:,:))/distY;
%         dZdx=(geopot(iLon+1,iLat,:,:)-geopot(iLon-1,iLat,:,:))/distX;
%         
%         %----- change by panxi: use f(lat) instead of constant f0
%         uGeostr(iLon,iLat,:,:)=-1/f(iLat)*dZdy;
%         vGeostr(iLon,iLat,:,:)=1/f(iLat)*dZdx;
%         
% 
%     end
% end
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
[nx,ny,nz,nt]=size(geopot);
f1=permute(repmat(f,[1,nx,nz,nt]),[2,1,3,4]);
%distX
distX=zeros(ny,1);
for j=2:ny-1
    distX(j)=lldistkm([lat(j) lon(3)],[lat(j) lon(1)])*1000;
end
distX=permute(repmat(distX,[1,nx,nz,nt]),[2,1,3,4]);
%distY
distY=lldistkm([lat(3) lon(1)],[lat(1) lon(1)])*1000;

dZdy=(geopot(2:nx-1, 3:ny  , :,:)- geopot(2:nx-1, 1:ny-2, :,:))/distY;
dZdx=(geopot(3:nx  , 2:ny-1, :,:)- geopot(1:nx-2, 2:ny-1, :,:))./distX(2:nx-1,2:ny-1,:,:);

uGeostr(2:nx-1,2:ny-1,:,:)=-1/f1(2:nx-1,2:ny-1,:,:).*dZdy;
vGeostr(2:nx-1,2:ny-1,:,:)=1/f1(2:nx-1,2:ny-1,:,:).*dZdx;
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^




