function [sigma,sigmaLoc]=calcSigma(temp,level)
% [sigma,sigmaLoc]=calcSigma(temp,level)
% sigmaLoc has the same dimonsion as temp (4D)
% sigma is the spatial and temperoal average

Rd=287;
kappa=0.286;

levelRepeat=permute(repmat(level,[1,size(temp,1),size(temp,2),size(temp,4)]),[2,3,1,4]);

potTemp=temp.*(1000/levelRepeat).^kappa;
logPotTemp=log(potTemp);

dLogThetadp=calcddp(logPotTemp,level);

sigmaLoc=-Rd*temp./(levelRepeat*100).*dLogThetadp;

sigma=squeeze(mean(mean(mean(sigmaLoc,4),2),1));
