function save_nc(savename,data,lon,lat,level,dataname)
% qgOmega=permute(qgOmega,[1,2,3,5,4]); 
data=single(data);
lon=single(lon);
lat=single(lat);
level=single(level);
fprintf(['save ',dataname,' ....\n']);

    %create a NetCDF  file
    ncmode=bitor(netcdf.getConstant('NC_SHARE'),netcdf.getConstant('NETCDF4'));
    ncid = netcdf.create(savename,ncmode);
    
    %define the dimentions
    tmp = size(data);  %nlon=144;nlat=73;nlev=32;nt=59;ntype=4;
    fprintf('size : ');disp(tmp);
    id1 = netcdf.defDim(ncid,'nlon',tmp(1));
    id2 = netcdf.defDim(ncid,'nlat',tmp(2));
    id3 = netcdf.defDim(ncid,'nlev',tmp(3));
    id4 = netcdf.defDim(ncid,'ntype',tmp(4));
    id5 = netcdf.defDim(ncid,'nt',netcdf.getConstant('NC_UNLIMITED'));
    
    %define the variables and their attributes
    vid1 =netcdf.defVar(ncid, dataname, 'float',[id1,id2,id3,id4,id5]); 
    vid4 =netcdf.defVar(ncid, 'lon','float',id1);
    vid5 =netcdf.defVar(ncid, 'lat', 'float',id2);
    vid6 =netcdf.defVar(ncid, 'level', 'float',id3);
    
    %压缩
    netcdf.defVarDeflate(ncid,vid1,true,true,5);
        
    %complete the definition of NetCDF
    netcdf.endDef(ncid);
    
    
    netcdf.putVar(ncid,vid1,[0,0,0,0,0],tmp,data);
    %netcdf.putVar(ncid,vid3,ifail);
    netcdf.putVar(ncid,vid4,lon);
    netcdf.putVar(ncid,vid5,lat);
    netcdf.putVar(ncid,vid6,level);

    %close the NetCDF file
    netcdf.close(ncid);
