function output=takeLaplacian_9point(field,lon,lat)
% output=takeLaplacian(field,lon,lat)
% field(lon,lat)

nlon=length(lon);
nlat=length(lat);

if size(field,1)~=nlon || size(field,2)~=nlat
    error('Field must have size: field(lon,lat)')
end

output=zeros(size(field));

%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
% for iLon=5:nlon-4
%    % disp([num2str(iLon) ' of ' num2str(nlon)])
%     for iLat=5:nlat-4
%         
%         distX=lldistkm([lat(iLat) lon(iLon+1)],[lat(iLat) lon(iLon-1)])*1000/2;
%         distY=lldistkm([lat(iLat+1) lon(iLon)],[lat(iLat-1) lon(iLon)])*1000/2;
%                     
% % from http://wweb.uta.edu/faculty/ricard/Classes/KINE-5350/Wood%20%281982%29%20Data%20smoothing.pdf
%         
%         d2dx2=(4*field(iLon-4,iLat,:,:)+4*field(iLon-3,iLat,:,:)+field(iLon-2,iLat,:,:)-4*field(iLon-1,iLat,:,:)-10*field(iLon,iLat,:,:)-4*field(iLon+1,iLat,:,:)+field(iLon+2,iLat,:,:)+4*field(iLon+3,iLat,:,:)+4*field(iLon+4,iLat,:,:))/100/distX^2;
%         d2dy2=(4*field(iLon,iLat-4,:,:)+4*field(iLon,iLat-3,:,:)+field(iLon,iLat-2,:,:)-4*field(iLon,iLat-1,:,:)-10*field(iLon,iLat,:,:)-4*field(iLon,iLat+1,:,:)+field(iLon,iLat+2,:,:)+4*field(iLon,iLat+3,:,:)+4*field(iLon,iLat+4,:,:))/100/distY^2;
%                     
%         output(iLon,iLat,:,:)=d2dx2+d2dy2;
% 
%     end
% end
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
[nlon,nlat,nlev,nt]=size(field);

iLon=5:nlon-4;
iLat=5:nlat-4;
        
%distX
distX=zeros(nlat,1);
for j=2:nlat-1
    distX(j)=lldistkm([lat(j) lon(3)],[lat(j) lon(1)])*1000/2;
end
distX=permute(repmat(distX,[1,nlon,nlev,nt]),[2,1,3,4]);
%distY
distY=lldistkm([lat(3) lon(1)],[lat(1) lon(1)])*1000/2;                   
        
d2dx2=(4*field(iLon-4,iLat,:,:)+4*field(iLon-3,iLat,:,:)+field(iLon-2,iLat,:,:)-4*field(iLon-1,iLat,:,:)-10*field(iLon,iLat,:,:)-4*field(iLon+1,iLat,:,:)+field(iLon+2,iLat,:,:)+4*field(iLon+3,iLat,:,:)+4*field(iLon+4,iLat,:,:))/100./(distX(iLon+1,iLat,:,:).^2);
d2dy2=(4*field(iLon,iLat-4,:,:)+4*field(iLon,iLat-3,:,:)+field(iLon,iLat-2,:,:)-4*field(iLon,iLat-1,:,:)-10*field(iLon,iLat,:,:)-4*field(iLon,iLat+1,:,:)+field(iLon,iLat+2,:,:)+4*field(iLon,iLat+3,:,:)+4*field(iLon,iLat+4,:,:))/100/distY^2;
                    
output(iLon,iLat,:,:)=d2dx2+d2dy2;
%^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

